# coding=UTF-8
import os
import pandas as pd
import sys

inSeqFile = sys.argv[1] #原始输入序列文件
work_path = os.path.dirname(inSeqFile)
prefix_name = work_path + "/" + os.path.basename(inSeqFile).split('.')[0]
outfile1 = prefix_name +'_CTDC.csv'
outfile2 = prefix_name +'_CTDT.csv'
outfile3 = prefix_name +'_CTDD.csv'
#分别生成C,T,D 三个特征文件
os.system('python ./PythonScripts/iFeatrue.py --file '+ inSeqFile + ' --type CTDC --out ' + outfile1)
os.system('python ./PythonScripts/iFeatrue.py --file ' + inSeqFile + ' --type CTDT --out ' + outfile2)
os.system('python ./PythonScripts/iFeatrue.py --file ' + inSeqFile + ' --type CTDD --out ' + outfile3)

#将三个文件进行合并
df1 = pd.read_csv(outfile1,header = 0).iloc[:,1:]
df2 = pd.read_csv(outfile2,header = 0).iloc[:,1:]
df3 = pd.read_csv(outfile3,header = 0).iloc[:,1:]
dataset = pd.concat([df1,df2,df3],axis=1)
outCTDfile = prefix_name +'_CTD.csv' #最终生成的CTD特征文件
dataset.to_csv(outCTDfile,index=False)
os.remove(outfile1)
os.remove(outfile2)
os.remove(outfile3)
#print("------Finished!------")