# coding=UTF-8
import os
import pandas as pd
import sys

'''
生成Bacteria数据集的特征文件：CTD+3-gap DC+PseAACw0.1lambda11
'''

def main(inSeqFile):
    #inSeqFile = sys.argv[1]
    work_path = os.path.dirname(inSeqFile)
    prefix_name = work_path + "/" + os.path.basename(inSeqFile).split('.')[0]
    cmds = []
    outfile1 = prefix_name + '_CTD.csv'
    cmds.append(r'python ./PythonScripts/CTD.py ' + inSeqFile)
    #os.system('python ./PythonScripts/CTD.py ' + inSeqFile)
    
    outfile2 = prefix_name + '_gap.csv'
    cmds.append(r'python ./PythonScripts/g-gap.py -g 3 -i ' + inSeqFile + ' -o ' + outfile2)
    #os.system('python ./PythonScripts/g-gap.py -g 3 -i ' + inSeqFile + ' -o ' + outfile2)
    
    outfile3 = prefix_name + '_PseAAC.csv'
    cmds.append(r'python ./PythonScripts/PseAAC_2type_ertai.py -t 2 -w 0.1 -r 11 -i ' + inSeqFile + ' -o ' + outfile3)
    #os.system('python ./PythonScripts/PseAAC_2type_ertai.py -t 2 -w 0.1 -r 11 -i ' + inSeqFile + ' -o ' + outfile3)
    for eachCmd in cmds:
        os.system(eachCmd)
        
    #将特征文件进行合并
    df2 = pd.read_csv(outfile1,header = 0)
    new_columns = [1]*df2.shape[0] #插入标签列
    df2.insert(0,'class',new_columns)
    df3 = pd.read_csv(outfile2,header = 0).iloc[:,1:]
    df4 = pd.read_csv(outfile3,header = 0).iloc[:,1:]
    dataset = pd.concat([df2,df3,df4],axis=1)
    outfile_bacteria = prefix_name + '_bacteria.csv'
    dataset.to_csv(outfile_bacteria,index=False)
    
    if os.path.exists(outfile_bacteria):
        os.remove(outfile1)
        os.remove(outfile2)
        os.remove(outfile3)
    else:
        pass
        