# coding=UTF-8
import os
import pandas as pd
import sys

'''
生成Eukaryote数据集的特征文件：CTD+6-gap DC
'''

def main(inSeqFile):
    #inSeqFile = sys.argv[1]
    work_path = os.path.dirname(inSeqFile)
    prefix_name = work_path + "/" + os.path.basename(inSeqFile).split('.')[0]
    
    outfile1 = prefix_name + '_CTD.csv'
    os.system('python ./PythonScripts/CTD.py ' + inSeqFile)

    outfile2 = prefix_name + '_gap.csv'
    os.system('python ./PythonScripts/g-gap.py -g 6 -i ' + inSeqFile + ' -o ' + outfile2)

    #将特征文件进行合并
    df2 = pd.read_csv(outfile1,header = 0)
    new_columns = [1]*df2.shape[0] #插入标签列
    df2.insert(0,'class',new_columns)
    df3 = pd.read_csv(outfile2,header = 0).iloc[:,1:]
    dataset = pd.concat([df2,df3],axis=1)
    outfile_eukaryote = prefix_name + '_eukaryote.csv'
    dataset.to_csv(outfile_eukaryote,index=False)
    
    if os.path.exists(outfile_eukaryote):
        os.remove(outfile1)
        os.remove(outfile2)
    else:
        pass