# coding=UTF-8
import pandas as pd
import sys,os

'''
生成General数据集的特征文件：NV+CTD+3-gap DC+PseAACw0.2lambda18
'''

def main(inSeqFile):
    #inSeqFile = sys.argv[1] #原始输入序列文件
    work_path = os.path.dirname(inSeqFile)
    prefix_name = work_path + "/" + os.path.basename(inSeqFile).split('.')[0]
    outfile1 = prefix_name + '_NV.csv'
    os.system('python ./PythonScripts/NV.py -i '+ inSeqFile +  ' -o ' + outfile1)
    
    outfile2 = prefix_name + '_CTD.csv'
    os.system('python ./PythonScripts/CTD.py ' + inSeqFile)
    
    outfile3 = prefix_name + '_gap.csv'
    os.system('python ./PythonScripts/g-gap.py -g 3 -i ' + inSeqFile + ' -o ' +  outfile3)
    
    outfile4 = prefix_name + '_PseAAC.csv' 
    os.system('python ./PythonScripts/PseAAC_2type_ertai.py -t 2 -w 0.2 -r 18 -i ' + inSeqFile + ' -o ' + outfile4)
    
    #将特征文件进行合并
    df1 = pd.read_csv(outfile1,header = 0)
    df2 = pd.read_csv(outfile2,header = 0)
    df3 = pd.read_csv(outfile3,header = 0).iloc[:,1:]
    df4 = pd.read_csv(outfile4,header = 0).iloc[:,1:]
    dataset = pd.concat([df1,df2,df3,df4],axis=1)
    outfile_general = prefix_name + '_general.csv'
    dataset.to_csv(outfile_general,index=False)
    
    if os.path.exists(outfile_general):
        os.remove(outfile1)
        os.remove(outfile2)
        os.remove(outfile3)
        os.remove(outfile4)
    else:
        pass
